<?php
# Copyright (c) 2006 Skyline-arts.com. All rights reserved.

# Classe Pluxml #
class pluxml{

	var $con;
	var $ccon;

	var $chr_start; # Microtime du dbut de l'execution

	var $config; # Tableau de configuration
	var $style; # Dossier contenant le thme
	var $racine; # Url de Pluxml
	var $bypage; # Nombre d'articles par page

	var $aCats; # Tableau de toutes les catgories
	var $uCats; # Tableau des catgories utilises

	var $page; # Numro de la page
	var $mode; # Mode
	var $motif; # Motif de recherche

	var $aFiles; # Tableau de tous les fichiers
	var $a_file_cat; # Tableau des fichiers de la catgories
	var $uFiles; # Tableau de fichiers  traiter

	var $result; # Tableau d'articles  afficher
	var $coms;

	function pluxml($file_config){

		$this->chr_start = date::ext_microtime();

		$this->get = getGets();
		
		$this->config = $this->getConfiguration($file_config);
		$this->aCats = $this->getCategories(PLX_DOC.$this->config['categories']);
		$this->racine = $this->config['racine'];
		$this->bypage =$this->config['bypage'];
		$this->style = $this->config['style'];
		
		$this->con = new myglob(PLX_DOC.$this->config['racine_xml']);
		$this->ccon = new myglob(PLX_DOC.$this->config['racine_xmlcom']);

		$this->aFiles = $this->con->query('/^[0-9]{4}.([0-9]{3}|home)(.[a-z0-9-]*)*.xml$/');
	}

	function getConfiguration($url_file){

		$data = implode("",file($url_file));
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
		xml_parser_free($parser);

		for($i=0;$i < count($index_tags['parametre']);$i++) {
			if(isset($valeurs[$index_tags['parametre'][$i]]['value'])){
				$array[$valeurs[$index_tags['parametre'][$i]]['attributes']['name']] =
				htmlspecialchars($valeurs[$index_tags['parametre'][$i]]['value']);
			}else{
				$array[$valeurs[$index_tags['parametre'][$i]]['attributes']['name']] = '';
			}
		}
		return $array;
	}

	function getCategories($url_file){

		$data = implode("",file($url_file));
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
		xml_parser_free($parser);

		if(isset($index_tags['categorie'])){
		for($i=0;$i < count($index_tags['categorie']);$i++) {
			$array[$valeurs[$index_tags['categorie'][$i]]['attributes']['number']]['name']
			= $valeurs[$index_tags['categorie'][$i]]['value'];
			$array[$valeurs[$index_tags['categorie'][$i]]['attributes']['number']]['url']
			= $valeurs[$index_tags['categorie'][$i]]['attributes']['url'];
		}
		for($i=0;$i < count($index_tags['categorie']);$i++) {
			$ordre[$valeurs[$index_tags['categorie'][$i]]['attributes']['ordre']]
			= $valeurs[$index_tags['categorie'][$i]]['attributes']['number'];
		}
		ksort($ordre);
		foreach($ordre as $key => $values) {
			if(array_key_exists($values, $array)){
				$final[$values]['name'] = $array[$values]['name'];
				$final[$values]['url'] = $array[$values]['url'];
				$final[$values]['ordre'] = $key;
			}
		}
		return $final;
		}
	}

	function getUsedCategories($prefixe=''){

		$array = array();
		foreach($this->aCats as $num => $info){
			$motif = '/^[0-9]{4}.'.$num.'(.[a-z0-9-]*)*.xml$/';
			if($this->con->query($motif)){
				$this->uCats[$num] = $this->aCats[$num];
			}
		}
	}

	function getMode($mode='',$motif='',$bypage=''){
	
		if($mode = $motif != ''){
			$this->mode = $mode;
			$this->motif = $motif;
			$this->bypage = $bypage;
		}
		elseif($this->get && preg_match('/^([0-9]*)-/',$this->get,$capture)){
			$capture['1'] = str_pad($capture[1],4, "0", STR_PAD_LEFT);
			$this->mode = 'article';
			$_GET['article'] = $capture[1];
			$this->motif = '/'.$capture[1].'.([0-9]{3}|home)(.[a-z0-9-]*)*.xml$/';
		}
		elseif($this->get && preg_match('/^([0-9]{3})\/([A-Z]*)/',$this->get,$capture)){
			$this->mode = 'cat';
			$this->motif = '/^[0-9]{4}.'.$capture['1'].'(.[a-z0-9-]*)*.xml$/';
		}else{
			$this->mode = 'home';
			if($this->con->query('/[0-9]{4}.home(.[a-z0-9-]*)*.xml$/')){
				$this->motif = '/[0-9]{4}.home(.[a-z0-9-]*)*.xml$/';
			}else{
				$this->motif = '/[0-9]{4}.[0-9]{3}(.[a-z0-9-]*)*.xml$/';
			}
		}
	}

	function pagination(){

		if (preg_match('/page([0-9]*)/',$this->get,$capture)){
			$this->page = $capture[1];
		}else{
			$this->page = 1;
		}
		if($this->motif == '/[0-9]{4}.home(.[a-z0-9-]*)*.xml$/'){
			$this->bypage = false;
		}
	}

	function getFiles(){

		$this->uFiles = $this->con->query($this->motif, 'rsort', $this->bypage*($this->page-1), $this->bypage);
		$this->cat_file_count = $this->con->gbl_count;
	}

	function getArticles(){

		foreach($this->uFiles as $i => $a) {
			$array[$i] = $this->parseArticle(PLX_DOC.$this->config['racine_xml'].$a);
		}
		$this->result = new recordset($array);
	}

	function parseArticle($filename){

		$data = implode("",file($filename));
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
		xml_parser_free($parser);

		$publication['title'] = $valeurs[$index_tags['title']['0']]['value'];
		$publication['author'] = $valeurs[$index_tags['author']['0']]['value'];
		$publication['date'] = $valeurs[$index_tags['date']['0']]['value'];
		$publication['allow_com'] = $valeurs[$index_tags['allow_com']['0']]['value'];
		$publication['filename'] = $filename;
		$publication['cat_num'] = fileInfo($filename, 'catId');
		$publication['file_num'] = fileInfo($filename, 'fileId');
		$publication['art_name'] = fileInfo($filename, 'artname');
		if(trim($valeurs[$index_tags['chapo']['0']]['value']) !== ''){
			$publication['chapo'] = $valeurs[$index_tags['chapo']['0']]['value'];
		}else{
			$publication['chapo'] = '';
		}
		$publication['content'] = $valeurs[$index_tags['content']['0']]['value'];
		$publication['size'] = filesize($filename);
		$publication['nb_com'] = $this->getNbComments($publication['file_num']);

		return $publication;
	}

	function parseComments($filename){

		$data = implode("",file($filename));
		$parser = xml_parser_create('ISO-8859-1');
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
		xml_parser_free($parser);

		for($i=0;$i < count($index_tags['author']);$i++) {
			$array[$i]['author'] =  $valeurs[$index_tags['author'][$i]]['value'];
			$array[$i]['date'] =  $valeurs[$index_tags['date'][$i]]['value'];
			$array[$i]['ip'] =  $valeurs[$index_tags['ip'][$i]]['value'];
			if(isset($valeurs[$index_tags['mail'][$i]]['value'])){
				$array[$i]['mail'] =  $valeurs[$index_tags['mail'][$i]]['value'];
			}else{
				$array[$i]['mail'] = '';
			}
			$array[$i]['site'] =  'http://'.str_replace('http://', '', $valeurs[$index_tags['site'][$i]]['value']);
			$array[$i]['content'] =  $valeurs[$index_tags['content'][$i]]['value'];
		}

		return $array;
	}

	function getComments() {

		$motif = '/com.'.$_GET['article'].'.xml$/';
		if($files = $this->ccon->query($motif, 'rsort', 0, 1)){
			$this->coms =  new recordset($this->parseComments(PLX_DOC.$this->config['racine_xmlcom'].$files[0]));
		}else{
			$this->coms = false;
		}
	}

	function newComment($article){
		global $capcha;
		if($this->config['capcha'] == 0 || $_POST['rep2'] == md5($capcha->grain_de_sel.$_POST['rep'])){
			if(!empty($_POST['name']) && !empty($_POST['message'])){
				$author = htmlentities(unslash(trim($_POST['name'])));
				$message = nl2br(htmlentities(unslash(trim($_POST['message']))));
				$date = date::isodate();
				$site = htmlentities(unslash(trim($_POST['site'])));
				$mail = htmlentities(unslash(trim($_POST['mail'])));
				$ip = $_SERVER['REMOTE_ADDR'];
				$filename = PLX_DOC.$this->config['racine_xmlcom'].'com.'.$article.'.xml';

				if(!file_exists($filename)){
					$this->createCommentFile($filename);
				}
				$this->addComment($filename, $author, $date, $ip, $mail, $site, $message);
			}
		}
	}
	function addComment($file, $author, $date, $ip, $mail, $site, $message){

		$data = implode("",file($file));
		$end = '</comments>';
		$add = "\t<comment>\n".
				"\t\t<author><![CDATA[$author]]></author>\n".
				"\t\t<date>$date</date>\n".
				"\t\t<ip>$ip</ip>\n".
				"\t\t<mail><![CDATA[$mail]]></mail>\n".
				"\t\t<site><![CDATA[$site]]></site>\n".
				"\t\t<content><![CDATA[$message]]></content>\n".
			"\t</comment>\n";
		$xml = str_replace($end, $add.$end, $data);
		write($xml, $file);
	}

	function createCommentFile($filename){
		
		$xml = "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>".
				"<comments>\n".
				"</comments>";
		write($xml, $filename);
	}

	function deleteComment($article, $comment){
		
		$filename = PLX_DOC.$this->config['racine_xmlcom'].'com.'.$article.'.xml';
		$this->getComments();
		$xml = "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>".
				"<comments>\n";
		while($this->coms->loop()){
			if(count($this->coms->result) < 2){
				unlink($filename);
				return;
			}
			if($this->coms->i != $comment){
				$xml .= "\t<comment>\n".
					"\t\t<author>".$this->coms->f('author')."</author>\n".
					"\t\t<date>".$this->coms->f('date')."</date>\n".
					"\t\t<ip>".$this->coms->f('ip')."</ip>\n".
					"\t\t<mail>".$this->coms->f('mail')."</mail>\n".
					"\t\t<site>".$this->coms->f('site')."</site>\n".
					"\t\t<content><![CDATA[".$this->coms->f('content')."]]></content>\n".
				"\t</comment>\n";
			}
		}

		$xml .= "</comments>";
		write($xml, $filename);

	}

	function editComment($article, $comment, $post){


		if(!empty($_POST['message'])){
			$message = unslash(trim($_POST['message']));

		$this->getComments();
		$xml = "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>".
				"<comments>\n";
		while($this->coms->loop()){
			if($this->coms->i == $comment){
				$xml .= "\t<comment>\n".
					"\t\t<author>".$this->coms->f('author')."</author>\n".
					"\t\t<date>".$this->coms->f('date')."</date>\n".
					"\t\t<ip>".$this->coms->f('ip')."</ip>\n".
					"\t\t<mail>".$this->coms->f('mail')."</mail>\n".
					"\t\t<site>".$this->coms->f('site')."</site>\n".
					"\t\t<content><![CDATA[".$message."]]></content>\n".
				"\t</comment>\n";
			}else{
				$xml .= "\t<comment>\n".
					"\t\t<author>".$this->coms->f('author')."</author>\n".
					"\t\t<date>".$this->coms->f('date')."</date>\n".
					"\t\t<ip>".$this->coms->f('ip')."</ip>\n".
					"\t\t<mail>".$this->coms->f('mail')."</mail>\n".
					"\t\t<site>".$this->coms->f('site')."</site>\n".
					"\t\t<content><![CDATA[".$this->coms->f('content')."]]></content>\n".
				"\t</comment>\n";
				}
		}

		$xml .= "</comments>";
		$filename = PLX_DOC.$this->config['racine_xmlcom'].'com.'.$article.'.xml';
		write($xml, $filename);
		}

	}

	function getNbComments($fileid){
		
		$filename = PLX_DOC.$this->config['racine_xmlcom'].'com.'.$fileid.'.xml';
		if(file_exists($filename)){
			$data = implode("",file($filename));
			$parser = xml_parser_create('ISO-8859-1');
			xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
			xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
			xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
			xml_parser_free($parser);
			if(isset($index_tags['author'])){
				return count($index_tags['author']);
			}
		}
		return 0;
	}

}
?>
