<?php
# Copyright (c) 2006 Skyline-arts.com. All rights reserved.

class date{

	function ext_microtime(){

		$t = explode(' ',microtime());
		return $t[0]+$t[1];
	}

	# dateRss2Hum
	# A partir d'une date au format Iso, retourne 'jour' 'num du jour' 'mois' 'anne'
	function dateIso2Hum($date_iso){

		$year = substr($date_iso, 0, 4);
		$month = substr($date_iso, 5, 2);
		$day = substr($date_iso, 8, 2);
		$day_num = date('w',mktime(0, 0, 0, $month, $day, $year));

		$ar_month = array(
			'01' => 'janvier','02' => 'fvrier','03' => 'mars','04' => 'avril','05' => 'mai','06' => 'juin',
			'07' => 'juillet','08' => 'aot','09' => 'septembre','10' => 'octobre','11' => 'novembre','12' => 'dcembre');

		$ar_day = array(
			'1' => 'lundi','2' => 'mardi','3' => 'mercredi',
			'4' => 'jeudi','5' => 'vendredi','6' => 'samedi','0' => 'dimanche');

		return ''.$ar_day[$day_num].' '.$day.' '.$ar_month[$month].' '.$year.'';
	}
	
	# heureRss2Hum
	# A partir d'une date au format Iso, retourne 'heure':'minute'
	function heureIso2Hum($date_iso){

		return ''.substr($date_iso, 11, 2).':'.substr($date_iso, 14, 2).'';
	}
	
	# heureIso2Admin
	# Spare les lments d'une date Iso et les met dans un tableau
	function heureIso2Admin($date){

		preg_match('/([0-9]{4})-([0-9]{2})-([0-9]{2})T([0-9:]{8})((\+|-)[0-9:]{5})/',$date,$capture);
		return array ('year' => $capture[1],'month' => $capture[2],'day' => $capture[3],'time' => $capture[4],'delta' => $capture[5],);
	}

	function isoDate() {

		$date = date('Y-m-d\TH:i:sO');
		return substr($date, 0, 22).':'.substr($date, 22, 2);
	}
}

function printSelect($name, $array, $selected=''){
	echo '<select name="'.$name.'">'."\n";
	foreach($array as $a => $b) {
		if(is_array($b)){
			echo '<optgroup label="'.$a.'">'."\n";
			foreach($b as $c=>$d){
				if($c == $selected) {
					echo "\t".'<option value="'.$c.'" selected="selected">'.$d.'</option>'."\n";
				}else{
					echo "\t".'<option value="'.$c.'">'.$d.'</option>'."\n";
				}
			}
			echo '</optgroup>'."\n";
		}else{
			if($a == $selected) {
				echo "\t".'<option value="'.$a.'" selected="selected">'.$b.'</option>'."\n";
			}else{
				echo "\t".'<option value="'.$a.'">'.$b.'</option>'."\n";
			}
		}
	}
	echo '</select>'."\n";
}

function printInput($name, $value='', $type='text', $size='50-255'){
	
	$size = explode('-',$size);
	echo '<input name="'.$name.'" type="'.$type.'" value="'.$value.'" size="'.$size[0].'" maxlength="'.$size[1].'" />'."\n";
}

function printArea($name, $value='', $cols='', $rows=''){

	echo '<textarea name="'.$name.'" cols="'.$cols.'" rows="'.$rows.'">'.$value.'</textarea>'."\n";
}

function analysePwd($filename){

	$data = implode("",file($filename));
	$parser = xml_parser_create('ISO-8859-1');
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_parse_into_struct($parser,$data,$valeurs,$index_tags);
	xml_parser_free($parser);

	for($i=0;$i < count($index_tags['user']);$i++) {
		$array[$valeurs[$index_tags['user'][$i]]['attributes']['login']] = $valeurs[$index_tags['user'][$i]]['value'];
	}
	return $array;
}


# fileInfo
# Suivant l'attribut 'output', retourne le numro d'article ou de catgorie d'un fichier
function fileInfo($filename, $output){

	if(preg_match('/([0-9]{4}).([0-9]{3}|home|draft)(.([a-z0-9-]*))*.xml$/',$filename,$capture)){
		if ($output == 'fileId'){
			return $capture[1];
		}
		if ($output == 'catId'){
			return $capture[2];
		}
		if ($output == 'artname'){
			return $capture[4];
		}
	}
}


# test_write
# Vrifie si le fichier est accessible en criture
function test_write($file){

	if(is_writable($file)){
		echo $file.' est accessible en criture';
	}else{
		echo '<strong>'.$file.' n\'est pas accessible en criture</strong>';
	}

}

function title2url($str){
	$str = strtolower($str);
	$str = strtr($str,
	"",
	"AAAAAAaaaaaaCcOOOOOOooooooEEEEeeeeIIIIiiiiUUUUuuuuYYyyNn");
	$str = preg_replace('/[\"\s\'\:\/\[\].,-]+/',' ',$str);
	$str = preg_replace('/[!@]/','',$str);
	return strtr(trim($str), ' ', '-');
}

function cat2url($str){
	return ucfirst(title2url($str));
}

function nodir($str){
	$a = explode('/',$str);
	return $a[count($a)-1];
}

function amp($str){
	return preg_replace('/&^([1-6]{2-4};){/','&amp; ',$str);
}

function getGets(){
	if(!empty($_GET)){
		$a = array_keys($_GET);
		return $a[0];
	}
	return false;
}

function formatRelatif($num, $lenght){
	
	$fnum = str_pad(abs($num), $lenght, '0', STR_PAD_LEFT);
	if($num > -1){
		return '+'.$fnum;
	}else{
		return '-'.$fnum;
	}
}

function unslash($content){

	if(get_magic_quotes_gpc() == 1){
		if(is_array($content)){
			foreach($content as $key => $data) {
				$new_content[$key] = stripslashes($data);
			}
		}else{
			$new_content = stripslashes($content);
		}
		return $new_content;
	}else{
		return $content;
	}
}

function write($xml, $filename){

	if(file_exists($filename)){
		$f=fopen($filename.'.tmp', 'w'); # On ouvre le fichier temporaire
		fwrite($f, trim($xml)); # On crit
		fclose($f); # On ferme
		unlink($filename);
		rename($filename.'.tmp', $filename); # On renomme le fichier temporaire avec le nom de l'ancien
	}else{
		$f=fopen($filename, 'w'); # On ouvre le fichier
		fwrite($f, trim($xml)); # On crit
		fclose($f); # On ferme
	}
	if(file_exists($filename) && !file_exists($filename.'.tmp')){
		return true;
	}else{
		return false;
	}

}

function makeThumb($filename, $filename_out, $width, $height, $quality){

	list($width_orig, $height_orig, $type) = getimagesize($filename);

	$ratio_w = $width / $width_orig;
	$ratio_h = $height / $height_orig;
	
	if($ratio_w < $ratio_h && $ratio_w < 1){
		$width = $ratio_w * $width_orig;
		$height = $ratio_w * $height_orig;
	}elseif($ratio_h < 1){
		$width = $ratio_h * $width_orig;
		$height = $ratio_h * $height_orig;
	}else{
		$width = $width_orig;
		$height = $height_orig;
		}
	
	$image_p = imagecreatetruecolor($width, $height);
	
	if($type == 2){
		$image = imagecreatefromjpeg($filename);
	}elseif($type == 3){
		$image = imagecreatefrompng($filename);
	}
	imagecopyresized($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
	
	if($type == 2){
		imagejpeg($image_p, $filename_out, $quality);
	}elseif($type == 3){
		imagepng($image_p, $filename_out);
	}
}

function showMsg($msg){

	if($msg){
		echo '<p class="msg"><strong>'.$msg.'</strong></p>'; 
	}
}

function racine(){
	$doc = str_replace('install.php', '', $_SERVER['REQUEST_URI']);
	return trim('http://'.$_SERVER['HTTP_HOST'].$doc);
}

function cdata($str){
		return '<![CDATA['.$str.']]>';
}
?>
