<?php
# This file is part of Pluxml.
# See 'index.php' for more informations
include('core/lib/lib.util.php');
if(file_exists('core/conf/configuration.xml')){
	header('Content-Type: text/plain');
	echo 'Pluxml est dj configur';
	exit;
}
# Configuration #
define('PLX_DOC', 'core/');
define('PLX_CONF', 'core/conf/configuration.xml');
define('PLX_XML', '<?xml version="1.0" encoding="ISO-8859-1"?>'."\n");
$f = file('version');
$version = $f['0'];
$config = array('title'=>'Pluxml', 'description'=>'le blog  l\'xml',
				'racine'=>racine(), 'delta'=>'+00:00', 'allow_com'=>1,
				'capcha'=>0, 'style'=>'defaut', 'bypage'=>5,
				'bypage_admin'=>10, 'bypage_rss'=>8,
				'images'=>'images/', 'racine_xml'=>'xml/',
				'racine_xmlcom'=>'xmlcom/','categories'=>'conf/categories.xml',
				'pwd'=>'conf/passwords.xml', 'version'=>$version
				);

function install($content, $config){
				
	$content = unslash($content);
	
	# Cration du fichier de configuration
	$xml = PLX_XML.'<document>';
	foreach($config as $a=>$b){
		$xml .= '<parametre name="'.$a.'">'.$b.'</parametre>'."\n";
	}
	$xml .= '</document>';
	write($xml,PLX_CONF);

	# Cration du fichier de mot de passe
	$xml = PLX_XML.'<document>
	<user login="'.$content['redac_name'].'">'.md5($content['redac_pwd']).'</user>
</document>';
	write($xml,PLX_DOC.$config['pwd']);


	# Cration du fichier de catgorie
	$xml = PLX_XML.'<document>
	<categorie number="001" ordre="1" url="Categorie">Catgorie 1</categorie>
</document>';
	write($xml,PLX_DOC.$config['categories']);

	# Cration du premier article
	$xml = PLX_XML.'<document>
	<infopost>
		<title>Premier article</title>
		<author>'.$content['redac_name'].'</author>
		<date>2006-01-01T00:00:00+00:00</date>
		<allow_com>1</allow_com>
	</infopost>
	<chapo>
		<![CDATA[]]>
	</chapo>
	<content>
		<![CDATA[<p>Ceci est un article cr lors de l\'installation. Editez-le depuis la zone d\'administration.</p>]]>
	</content>
</document>';
	write($xml,PLX_DOC.$config['racine_xml'].'0001.001.premier-article.xml');
}
	
if (!empty($_POST['redac_name']) && !empty($_POST['redac_pwd']) && $_POST['redac_pwd']==$_POST['redac_pwd2'] ) {
	install($_POST,$config);
	header('Location: '.racine());
}

?>


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
<title>Pluxml - Installation</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" type="text/css" href="core/admin/admin.css" media="screen" />
</head>

<body>
<h2>Installation de Pluxml</h2>

<ul>
	<li>Version : <?php echo $version; ?></li>
	<li><strong><?php test_write('core/conf/'); ?></strong></li>
	<li><strong><?php test_write('core/xml/'); ?></strong></li>
	<li><strong><?php test_write('core/xmlcom/'); ?></strong></li>
	<li>Version de php : <?php echo phpversion(); ?></li>
	<li>Etat des "magic quotes" : <?php echo get_magic_quotes_gpc(); ?></li>
</ul>

<form action="install.php" method="post">
	<fieldset>
		<p class="field"><label>Nom du rdacteur&nbsp;:</label></p>
		<?php printInput('redac_name', '', 'text', 50-255);?>
		<p class="field"><label>Mot de passe du rdacteur&nbsp;:</label></p>
		<?php printInput('redac_pwd', '', 'password', 50-255);?>
		<p class="field"><label>Confirmation du mot de passe&nbsp;:</label></p>
		<?php printInput('redac_pwd2', '', 'password', 50-255);?>
		<?php printInput('version', $version, 'hidden', 50-255);?>
	</fieldset>
	
	<fieldset>
		<p><input type="submit" value="Installer" /></p>
	</fieldset>
</form>
</body>
</html>
